Linux s17.hosterpk.com 6.12.0-124.55.3.el10_1.x86_64 #1 SMP PREEMPT_DYNAMIC Thu May 7 16:54:02 EDT 2026 x86_64
LiteSpeed
Server IP : 192.169.89.90 & Your IP : 216.73.216.41
Domains :
Cant Read [ /etc/named.conf ]
User : hamzalar
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
bin /
Delete
Unzip
Name
Size
Permission
Date
Action
GET
15.87
KB
-rwxr-xr-x
2024-10-29 00:00
MagickCore-config
1.77
KB
-rwxr-xr-x
2025-03-30 00:00
MagickWand-config
1.59
KB
-rwxr-xr-x
2025-03-30 00:00
Mail
1.01
MB
-rwxr-xr-x
2024-10-29 00:00
[
47.91
KB
-rwxr-xr-x
2026-01-15 00:00
aclocal
35.18
KB
-rwxr-xr-x
2024-11-27 00:00
aclocal-1.16
35.18
KB
-rwxr-xr-x
2024-11-27 00:00
addr2line
32.07
KB
-rwxr-xr-x
2026-02-04 00:00
animate
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
ar
60.41
KB
-rwxr-xr-x
2026-02-04 00:00
arch
35.8
KB
-rwxr-xr-x
2026-01-15 00:00
arpaname
15.43
KB
-rwxr-xr-x
2026-03-27 00:00
as
687.16
KB
-rwxr-xr-x
2026-02-04 00:00
aspell
150.35
KB
-rwxr-xr-x
2024-10-29 00:00
at
1.25
KB
-rwxr-xr-x
2025-09-19 00:00
atq
1.25
KB
-rwxr-xr-x
2025-09-19 00:00
atrm
1.25
KB
-rwxr-xr-x
2025-09-19 00:00
autoconf
14.85
KB
-rwxr-xr-x
2025-03-14 00:00
autoheader
8.82
KB
-rwxr-xr-x
2025-03-14 00:00
autom4te
32.69
KB
-rwxr-xr-x
2025-03-14 00:00
automake
255.91
KB
-rwxr-xr-x
2024-11-27 00:00
automake-1.16
255.91
KB
-rwxr-xr-x
2024-11-27 00:00
autoreconf
26.3
KB
-rwxr-xr-x
2025-03-14 00:00
autoscan
16.77
KB
-rwxr-xr-x
2025-03-14 00:00
autoupdate
33.22
KB
-rwxr-xr-x
2025-03-14 00:00
awk
745.91
KB
-rwxr-xr-x
2024-10-29 00:00
b2sum
55.91
KB
-rwxr-xr-x
2026-01-15 00:00
base32
39.82
KB
-rwxr-xr-x
2026-01-15 00:00
base64
39.84
KB
-rwxr-xr-x
2026-01-15 00:00
basename
35.8
KB
-rwxr-xr-x
2026-01-15 00:00
basenc
52.19
KB
-rwxr-xr-x
2026-01-15 00:00
bash
1.35
MB
-rwxr-xr-x
2024-10-29 00:00
bashbug-64
7.11
KB
-rwxr-xr-x
2024-10-29 00:00
batch
140
B
-rwxr-xr-x
2025-09-19 00:00
bison
494.29
KB
-rwxr-xr-x
2024-10-29 00:00
bunzip2
39.77
KB
-rwxr-xr-x
2024-12-19 00:00
bzcat
39.77
KB
-rwxr-xr-x
2024-12-19 00:00
bzcmp
2.09
KB
-rwxr-xr-x
2024-12-19 00:00
bzdiff
2.09
KB
-rwxr-xr-x
2024-12-19 00:00
bzgrep
2.01
KB
-rwxr-xr-x
2024-12-19 00:00
bzip2
39.77
KB
-rwxr-xr-x
2024-12-19 00:00
bzip2recover
19.55
KB
-rwxr-xr-x
2024-12-19 00:00
bzless
1.23
KB
-rwxr-xr-x
2024-12-19 00:00
bzmore
1.23
KB
-rwxr-xr-x
2024-12-19 00:00
c++
1.32
MB
-rwxr-xr-x
2026-02-26 00:00
c++filt
27.52
KB
-rwxr-xr-x
2026-02-04 00:00
c89
228
B
-rwxr-xr-x
2026-02-26 00:00
c99
219
B
-rwxr-xr-x
2026-02-26 00:00
cagefs_enter.proxied
1.27
KB
-rwxr-xr-x
2025-12-07 00:00
cal
52.21
KB
-rwxr-xr-x
2026-01-15 00:00
captoinfo
92.23
KB
-rwxr-xr-x
2026-03-24 00:00
cat
39.79
KB
-rwxr-xr-x
2026-01-15 00:00
cc
1.31
MB
-rwxr-xr-x
2026-02-26 00:00
chcon
64.42
KB
-rwxr-xr-x
2026-01-15 00:00
chgrp
64.41
KB
-rwxr-xr-x
2026-01-15 00:00
chmod
60.39
KB
-rwxr-xr-x
2026-01-15 00:00
chown
64.41
KB
-rwxr-xr-x
2026-01-15 00:00
chrt
31.76
KB
-rwxr-xr-x
2026-01-15 00:00
cksum
100.29
KB
-rwxr-xr-x
2026-01-15 00:00
cldetect
10.34
KB
-rwxr-xr-x
2026-05-14 00:00
clear
15.48
KB
-rwxr-xr-x
2026-03-24 00:00
clusterdb
68.76
KB
-rwxr-xr-x
2026-02-27 00:00
cmp
48
KB
-rwxr-xr-x
2024-10-29 00:00
col
23.61
KB
-rwxr-xr-x
2026-01-15 00:00
colcrt
19.53
KB
-rwxr-xr-x
2026-01-15 00:00
colrm
15.52
KB
-rwxr-xr-x
2026-01-15 00:00
column
43.76
KB
-rwxr-xr-x
2026-01-15 00:00
comm
39.94
KB
-rwxr-xr-x
2026-01-15 00:00
compare
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
composite
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
conjure
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
convert
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
cp
133.3
KB
-rwxr-xr-x
2026-01-15 00:00
cpan
8.37
KB
-rwxr-xr-x
2025-03-03 00:00
cpp
1.32
MB
-rwxr-xr-x
2026-02-26 00:00
createdb
72.94
KB
-rwxr-xr-x
2026-02-27 00:00
createuser
73.28
KB
-rwxr-xr-x
2026-02-27 00:00
crontab
1.49
KB
-rwxr-xr-x
2026-01-14 00:00
crontab.cagefs
40.51
KB
-rwxr-xr-x
2026-04-27 00:00
csplit
52.1
KB
-rwxr-xr-x
2026-01-15 00:00
curl
209.31
KB
-rwxr-xr-x
2025-11-17 00:00
cut
47.95
KB
-rwxr-xr-x
2026-01-15 00:00
date
96.1
KB
-rwxr-xr-x
2026-01-15 00:00
dbiprof
6.06
KB
-rwxr-xr-x
2024-10-29 00:00
dd
64.27
KB
-rwxr-xr-x
2026-01-15 00:00
delv
46.64
KB
-rwxr-xr-x
2026-03-27 00:00
df
68.77
KB
-rwxr-xr-x
2026-01-15 00:00
diff
153.17
KB
-rwxr-xr-x
2024-10-29 00:00
diff3
64.14
KB
-rwxr-xr-x
2024-10-29 00:00
dig
153.1
KB
-rwxr-xr-x
2026-03-27 00:00
dir
141.85
KB
-rwxr-xr-x
2026-01-15 00:00
dircolors
47.9
KB
-rwxr-xr-x
2026-01-15 00:00
dirname
31.63
KB
-rwxr-xr-x
2026-01-15 00:00
display
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
dnstap-read
23.53
KB
-rwxr-xr-x
2026-03-27 00:00
dropdb
64.59
KB
-rwxr-xr-x
2026-02-27 00:00
dropuser
64.53
KB
-rwxr-xr-x
2026-02-27 00:00
du
96.74
KB
-rwxr-xr-x
2026-01-15 00:00
echo
31.62
KB
-rwxr-xr-x
2026-01-15 00:00
ed
60.17
KB
-rwxr-xr-x
2024-10-29 00:00
egrep
106
B
-rwxr-xr-x
2024-10-29 00:00
enc2xs
40.82
KB
-rwxr-xr-x
2024-10-29 00:00
enchant
23.48
KB
-rwxr-xr-x
2025-01-16 00:00
enchant-lsmod
15.48
KB
-rwxr-xr-x
2025-01-16 00:00
env
48.38
KB
-rwxr-xr-x
2026-01-15 00:00
eps2eps
643
B
-rwxr-xr-x
2025-05-07 00:00
eqn
152.63
KB
-rwxr-xr-x
2024-10-29 00:00
ex
1.62
MB
-rwxr-xr-x
2026-04-08 00:00
expand
39.89
KB
-rwxr-xr-x
2026-01-15 00:00
expr
43.81
KB
-rwxr-xr-x
2026-01-15 00:00
factor
64.09
KB
-rwxr-xr-x
2026-01-15 00:00
false
27.59
KB
-rwxr-xr-x
2026-01-15 00:00
fc-cache
139
B
-rwxr-xr-x
2024-10-29 00:00
fc-cache-64
23.48
KB
-rwxr-xr-x
2024-10-29 00:00
fc-cat
19.48
KB
-rwxr-xr-x
2024-10-29 00:00
fc-conflist
15.45
KB
-rwxr-xr-x
2024-10-29 00:00
fc-list
15.46
KB
-rwxr-xr-x
2024-10-29 00:00
fc-match
15.46
KB
-rwxr-xr-x
2024-10-29 00:00
fc-pattern
15.46
KB
-rwxr-xr-x
2024-10-29 00:00
fc-query
15.46
KB
-rwxr-xr-x
2024-10-29 00:00
fc-scan
15.46
KB
-rwxr-xr-x
2024-10-29 00:00
fc-validate
15.46
KB
-rwxr-xr-x
2024-10-29 00:00
fgrep
106
B
-rwxr-xr-x
2024-10-29 00:00
file
31.93
KB
-rwxr-xr-x
2026-02-23 00:00
find
204.32
KB
-rwxr-xr-x
2024-10-29 00:00
flex
315.74
KB
-rwxr-xr-x
2024-10-29 00:00
flex++
315.74
KB
-rwxr-xr-x
2024-10-29 00:00
flock
23.71
KB
-rwxr-xr-x
2026-01-15 00:00
fmt
43.89
KB
-rwxr-xr-x
2026-01-15 00:00
fold
39.81
KB
-rwxr-xr-x
2026-01-15 00:00
free
23.58
KB
-rwxr-xr-x
2026-01-15 00:00
freetype-config
4.37
KB
-rwxr-xr-x
2024-10-29 00:00
funzip
35.55
KB
-rwxr-xr-x
2025-04-07 00:00
g++
1.32
MB
-rwxr-xr-x
2026-02-26 00:00
gawk
745.91
KB
-rwxr-xr-x
2024-10-29 00:00
gcc
1.31
MB
-rwxr-xr-x
2026-02-26 00:00
gcc-ar
31.62
KB
-rwxr-xr-x
2026-02-26 00:00
gcc-nm
31.62
KB
-rwxr-xr-x
2026-02-26 00:00
gcc-ranlib
31.62
KB
-rwxr-xr-x
2026-02-26 00:00
gcov
535.2
KB
-rwxr-xr-x
2026-02-26 00:00
gcov-dump
432.82
KB
-rwxr-xr-x
2026-02-26 00:00
gcov-tool
457.48
KB
-rwxr-xr-x
2026-02-26 00:00
gem
249
B
-rwxr-xr-x
2026-04-28 00:00
gencat
31.54
KB
-rwxr-xr-x
2026-05-26 00:00
geoiplookup
15.53
KB
-rwxr-xr-x
2019-11-28 00:00
geoiplookup6
15.48
KB
-rwxr-xr-x
2019-11-28 00:00
geqn
152.63
KB
-rwxr-xr-x
2024-10-29 00:00
getconf
27.31
KB
-rwxr-xr-x
2026-05-26 00:00
getent
31.95
KB
-rwxr-xr-x
2026-05-26 00:00
getopt
23.62
KB
-rwxr-xr-x
2026-01-15 00:00
ghostscript
15.45
KB
-rwxr-xr-x
2025-05-07 00:00
git
4.32
MB
-rwxr-xr-x
2026-01-09 00:00
git-receive-pack
4.32
MB
-rwxr-xr-x
2026-01-09 00:00
git-shell
819.72
KB
-rwxr-xr-x
2026-01-09 00:00
git-upload-archive
4.32
MB
-rwxr-xr-x
2026-01-09 00:00
git-upload-pack
4.32
MB
-rwxr-xr-x
2026-01-09 00:00
gm
15.41
KB
-rwxr-xr-x
2024-09-24 00:00
gmake
280.74
KB
-rwxr-xr-x
2024-11-05 00:00
gneqn
916
B
-rwxr-xr-x
2024-10-29 00:00
gnroff
5.58
KB
-rwxr-xr-x
2024-10-29 00:00
gpg
1.11
MB
-rwxr-xr-x
2026-02-06 00:00
gpg-agent
371.18
KB
-rwxr-xr-x
2026-02-06 00:00
gpg-error
35.75
KB
-rwxr-xr-x
2024-10-29 00:00
gpgsplit
27.82
KB
-rwxr-xr-x
2026-02-06 00:00
gpgv
315.91
KB
-rwxr-xr-x
2026-02-06 00:00
gpic
180.8
KB
-rwxr-xr-x
2024-10-29 00:00
gprof
97.8
KB
-rwxr-xr-x
2026-02-04 00:00
grep
165.82
KB
-rwxr-xr-x
2024-10-29 00:00
groff
76.36
KB
-rwxr-xr-x
2024-10-29 00:00
grops
146.32
KB
-rwxr-xr-x
2024-10-29 00:00
grotty
105.2
KB
-rwxr-xr-x
2024-10-29 00:00
groups
35.81
KB
-rwxr-xr-x
2026-01-15 00:00
gs
15.45
KB
-rwxr-xr-x
2025-05-07 00:00
gsnd
281
B
-rwxr-xr-x
2025-05-07 00:00
gtar
429.65
KB
-rwxr-xr-x
2026-02-23 00:00
gtbl
129.91
KB
-rwxr-xr-x
2024-10-29 00:00
gtroff
551.38
KB
-rwxr-xr-x
2024-10-29 00:00
gunzip
2.28
KB
-rwxr-xr-x
2024-10-29 00:00
gzexe
6.29
KB
-rwxr-xr-x
2024-10-29 00:00
gzip
97.35
KB
-rwxr-xr-x
2024-10-29 00:00
h2ph
28.3
KB
-rwxr-xr-x
2025-07-10 00:00
h2xs
59.51
KB
-rwxr-xr-x
2025-07-10 00:00
head
43.95
KB
-rwxr-xr-x
2026-01-15 00:00
hexdump
47.79
KB
-rwxr-xr-x
2026-01-15 00:00
host
121.02
KB
-rwxr-xr-x
2026-03-27 00:00
hostid
35.79
KB
-rwxr-xr-x
2026-01-15 00:00
hostname
23.51
KB
-rwxr-xr-x
2024-10-29 00:00
hunspell
102.2
KB
-rwxr-xr-x
2024-10-29 00:00
iconv
68.23
KB
-rwxr-xr-x
2026-05-26 00:00
icu-config
205
B
-rwxr-xr-x
2025-07-08 00:00
icu-config-64
21.65
KB
-rwxr-xr-x
2025-07-08 00:00
icuinfo
15.81
KB
-rwxr-xr-x
2025-07-08 00:00
id
43.86
KB
-rwxr-xr-x
2026-01-15 00:00
identify
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
idn
36.15
KB
-rwxr-xr-x
2024-07-18 00:00
ifnames
4.08
KB
-rwxr-xr-x
2025-03-14 00:00
import
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
infocmp
68.02
KB
-rwxr-xr-x
2026-03-24 00:00
infotocap
92.23
KB
-rwxr-xr-x
2026-03-24 00:00
install
141.4
KB
-rwxr-xr-x
2026-01-15 00:00
instmodsh
4.1
KB
-rwxr-xr-x
2024-10-29 00:00
ionice
19.56
KB
-rwxr-xr-x
2026-01-15 00:00
ipcrm
19.59
KB
-rwxr-xr-x
2026-01-15 00:00
ipcs
39.67
KB
-rwxr-xr-x
2026-01-15 00:00
isosize
15.49
KB
-rwxr-xr-x
2026-01-15 00:00
ispell
992
B
-rwxr-xr-x
2023-12-03 05:09
join
52.05
KB
-rwxr-xr-x
2026-01-15 00:00
kill
35.77
KB
-rwxr-xr-x
2026-01-15 00:00
ld
1.13
MB
-rwxr-xr-x
2026-05-27 07:02
ld.bfd
1.13
MB
-rwxr-xr-x
2026-05-27 07:02
ldd
5.27
KB
-rwxr-xr-x
2026-05-26 00:00
less
227.85
KB
-rwxr-xr-x
2024-10-29 00:00
lessecho
15.51
KB
-rwxr-xr-x
2024-10-29 00:00
lesskey
23.56
KB
-rwxr-xr-x
2024-10-29 00:00
lesspipe.sh
3.52
KB
-rwxr-xr-x
2024-10-29 00:00
lex
315.74
KB
-rwxr-xr-x
2024-10-29 00:00
libnetcfg
15.41
KB
-rwxr-xr-x
2025-07-10 00:00
libtool
367.87
KB
-rwxr-xr-x
2024-10-29 00:00
libtoolize
133.48
KB
-rwxr-xr-x
2024-10-29 00:00
link
35.8
KB
-rwxr-xr-x
2026-01-15 00:00
ln
60.26
KB
-rwxr-xr-x
2026-01-15 00:00
locale
51.15
KB
-rwxr-xr-x
2026-05-26 00:00
localedef
314.2
KB
-rwxr-xr-x
2026-05-26 00:00
logger
40.4
KB
-rwxr-xr-x
2026-01-15 00:00
login
47.9
KB
-rwxr-xr-x
2026-01-15 00:00
logname
35.78
KB
-rwxr-xr-x
2026-01-15 00:00
look
19.51
KB
-rwxr-xr-x
2026-01-15 00:00
ls
141.88
KB
-rwxr-xr-x
2026-01-15 00:00
lto-dump
35.33
MB
-rwxr-xr-x
2026-02-26 00:00
m4
251.59
KB
-rwxr-xr-x
2024-10-29 00:00
magick
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
magick-script
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
mail
1.01
MB
-rwxr-xr-x
2024-10-29 00:00
mailx
1.01
MB
-rwxr-xr-x
2024-10-29 00:00
make
280.74
KB
-rwxr-xr-x
2024-11-05 00:00
make-dummy-cert
614
B
-rwxr-xr-x
2026-05-20 00:00
mariadb
5.24
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-access
109.34
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-admin
686.82
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-binlog
4.89
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-check
4.68
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-conv
4.37
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-dump
4.78
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-embedded
20.49
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-find-rows
3.21
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-import
4.67
MB
-rwxr-xr-x
2026-02-10 00:00
mariadb-plugin
412.75
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-secure-installation
13.48
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-setpermission
17.56
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-show
673.63
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-slap
692.81
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-tzinfo-to-sql
448.5
KB
-rwxr-xr-x
2026-02-10 00:00
mariadb-waitpid
387.6
KB
-rwxr-xr-x
2026-02-10 00:00
mcookie
27.64
KB
-rwxr-xr-x
2026-01-15 00:00
md5sum
39.79
KB
-rwxr-xr-x
2026-01-15 00:00
mesg
15.49
KB
-rwxr-xr-x
2026-01-15 00:00
mkdir
64.47
KB
-rwxr-xr-x
2026-01-15 00:00
mkfifo
44.02
KB
-rwxr-xr-x
2026-01-15 00:00
mknod
48.06
KB
-rwxr-xr-x
2026-01-15 00:00
mktemp
39.88
KB
-rwxr-xr-x
2026-01-15 00:00
mogrify
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
montage
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
more
47.83
KB
-rwxr-xr-x
2026-01-15 00:00
msql2mysql
1.42
KB
-rwxr-xr-x
2026-02-10 00:00
mv
125.23
KB
-rwxr-xr-x
2026-01-15 00:00
my_print_defaults
432.45
KB
-rwxr-xr-x
2026-02-10 00:00
mysql
5.24
MB
-rwxr-xr-x
2026-02-10 00:00
mysql_config
4.5
KB
-rwxr-xr-x
2026-02-10 00:00
mysql_find_rows
3.21
KB
-rwxr-xr-x
2026-02-10 00:00
mysql_waitpid
387.6
KB
-rwxr-xr-x
2026-02-10 00:00
mysqlaccess
109.34
KB
-rwxr-xr-x
2026-02-10 00:00
mysqladmin
686.82
KB
-rwxr-xr-x
2026-02-10 00:00
mysqlbinlog
4.89
MB
-rwxr-xr-x
2026-02-10 00:00
mysqlcheck
4.68
MB
-rwxr-xr-x
2026-02-10 00:00
mysqldump
4.78
MB
-rwxr-xr-x
2026-02-10 00:00
mysqlimport
4.67
MB
-rwxr-xr-x
2026-02-10 00:00
mysqlshow
673.63
KB
-rwxr-xr-x
2026-02-10 00:00
mytop
72.03
KB
-rwxr-xr-x
2026-02-10 00:00
named-checkzone
31.68
KB
-rwxr-xr-x
2026-03-27 00:00
named-compilezone
31.68
KB
-rwxr-xr-x
2026-03-27 00:00
named-nzd2nzf
15.44
KB
-rwxr-xr-x
2026-03-27 00:00
namei
23.59
KB
-rwxr-xr-x
2026-01-15 00:00
nano
285.3
KB
-rwxr-xr-x
2024-12-11 00:00
neqn
916
B
-rwxr-xr-x
2024-10-29 00:00
nice
35.77
KB
-rwxr-xr-x
2026-01-15 00:00
nl
39.95
KB
-rwxr-xr-x
2026-01-15 00:00
nm
49.11
KB
-rwxr-xr-x
2026-02-04 00:00
nohup
35.71
KB
-rwxr-xr-x
2026-01-15 00:00
nproc
35.82
KB
-rwxr-xr-x
2026-01-15 00:00
nroff
5.58
KB
-rwxr-xr-x
2024-10-29 00:00
nsec3hash
15.52
KB
-rwxr-xr-x
2026-03-27 00:00
nslookup
120.98
KB
-rwxr-xr-x
2026-03-27 00:00
nsupdate
84.19
KB
-rwxr-xr-x
2026-03-27 00:00
numfmt
60
KB
-rwxr-xr-x
2026-01-15 00:00
objcopy
189.84
KB
-rwxr-xr-x
2026-02-04 00:00
objdump
434.15
KB
-rwxr-xr-x
2026-02-04 00:00
od
60.2
KB
-rwxr-xr-x
2026-01-15 00:00
openssl
968.7
KB
-rwxr-xr-x
2026-05-20 00:00
pango-list
19.44
KB
-rwxr-xr-x
2024-10-29 00:00
pango-segmentation
19.45
KB
-rwxr-xr-x
2024-10-29 00:00
pango-view
68.49
KB
-rwxr-xr-x
2024-10-29 00:00
passenger
1.73
KB
-rwxr-xr-x
2026-05-22 00:00
passwd
1.26
KB
-rwxr-xr-x
2026-02-23 00:00
paste
39.73
KB
-rwxr-xr-x
2026-01-15 00:00
patch
194.23
KB
-rwxr-xr-x
2024-10-29 00:00
pathchk
35.8
KB
-rwxr-xr-x
2026-01-15 00:00
pdf2dsc
701
B
-rwxr-xr-x
2025-05-07 00:00
pdf2ps
913
B
-rwxr-xr-x
2025-05-07 00:00
perl
15.29
KB
-rwxr-xr-x
2025-07-10 00:00
perl5.40.2
15.29
KB
-rwxr-xr-x
2025-07-10 00:00
perlbug
44.13
KB
-rwxr-xr-x
2025-07-10 00:00
perldoc
118
B
-rwxr-xr-x
2024-10-29 00:00
perlivp
10.56
KB
-rwxr-xr-x
2025-07-10 00:00
perlml
14.48
KB
-rwxr-xr-x
2025-10-02 00:00
perlthanks
44.13
KB
-rwxr-xr-x
2025-07-10 00:00
pg_dump
435.01
KB
-rwxr-xr-x
2026-02-27 00:00
pg_dumpall
114.11
KB
-rwxr-xr-x
2026-02-27 00:00
pg_restore
188.34
KB
-rwxr-xr-x
2026-02-27 00:00
pgrep
35.73
KB
-rwxr-xr-x
2026-01-15 00:00
php
937
B
-rwxr-xr-x
2025-03-26 00:00
pic
180.8
KB
-rwxr-xr-x
2024-10-29 00:00
piconv
8.08
KB
-rwxr-xr-x
2024-10-29 00:00
ping
157.7
KB
-rwxr-xr-x
2025-10-13 00:00
pinky
39.77
KB
-rwxr-xr-x
2026-01-15 00:00
pkg-config
335
B
-rwxr-xr-x
2024-10-29 00:00
pkill
35.73
KB
-rwxr-xr-x
2026-01-15 00:00
pl2pm
4.43
KB
-rwxr-xr-x
2025-07-10 00:00
pmap
35.67
KB
-rwxr-xr-x
2026-01-15 00:00
pod2html
3.95
KB
-rwxr-xr-x
2025-07-10 00:00
pod2man
18.46
KB
-rwxr-xr-x
2024-10-29 00:00
pod2text
12.8
KB
-rwxr-xr-x
2024-10-29 00:00
pod2usage
4.01
KB
-rwxr-xr-x
2024-10-29 00:00
podchecker
3.64
KB
-rwxr-xr-x
2024-10-29 00:00
post-grohtml
182.88
KB
-rwxr-xr-x
2024-10-29 00:00
pr
76.44
KB
-rwxr-xr-x
2026-01-15 00:00
pre-grohtml
56.35
KB
-rwxr-xr-x
2024-10-29 00:00
precat
5.53
KB
-rwxr-xr-x
2023-12-03 05:09
preunzip
5.53
KB
-rwxr-xr-x
2023-12-03 05:09
prezip
5.53
KB
-rwxr-xr-x
2023-12-03 05:09
prezip-bin
15.43
KB
-rwxr-xr-x
2024-10-29 00:00
printenv
35.62
KB
-rwxr-xr-x
2026-01-15 00:00
printf
43.87
KB
-rwxr-xr-x
2026-01-15 00:00
prove
13.26
KB
-rwxr-xr-x
2024-10-29 00:00
ps
121.77
KB
-rwxr-xr-x
2026-01-15 00:00
ps2ascii
635
B
-rwxr-xr-x
2025-05-07 00:00
ps2epsi
1.24
KB
-rwxr-xr-x
2025-05-07 00:00
ps2pdf
276
B
-rwxr-xr-x
2025-05-07 00:00
ps2pdf12
219
B
-rwxr-xr-x
2025-05-07 00:00
ps2pdf13
219
B
-rwxr-xr-x
2025-05-07 00:00
ps2pdf14
219
B
-rwxr-xr-x
2025-05-07 00:00
ps2pdfwr
1.06
KB
-rwxr-xr-x
2025-05-07 00:00
ps2ps
651
B
-rwxr-xr-x
2025-05-07 00:00
ps2ps2
673
B
-rwxr-xr-x
2025-05-07 00:00
psql
694.47
KB
-rwxr-xr-x
2026-02-27 00:00
ptx
56.01
KB
-rwxr-xr-x
2026-01-15 00:00
pwd
35.83
KB
-rwxr-xr-x
2026-01-15 00:00
pwdx
15.49
KB
-rwxr-xr-x
2026-01-15 00:00
pydoc
79
B
-rwxr-xr-x
2026-04-16 00:00
pydoc3
79
B
-rwxr-xr-x
2026-04-16 00:00
pydoc3.12
79
B
-rwxr-xr-x
2026-04-16 00:00
ranlib
60.42
KB
-rwxr-xr-x
2026-02-04 00:00
readelf
792.37
KB
-rwxr-xr-x
2026-02-04 00:00
readlink
43.89
KB
-rwxr-xr-x
2026-01-15 00:00
realpath
43.95
KB
-rwxr-xr-x
2026-01-15 00:00
recode
31.75
KB
-rwxr-xr-x
2024-07-17 00:00
red
92
B
-rwxr-xr-x
2024-10-29 00:00
reindexdb
81.07
KB
-rwxr-xr-x
2026-02-27 00:00
rename
23.58
KB
-rwxr-xr-x
2026-01-15 00:00
renew-dummy-cert
729
B
-rwxr-xr-x
2026-05-20 00:00
renice
15.51
KB
-rwxr-xr-x
2026-01-15 00:00
replace
395.03
KB
-rwxr-xr-x
2026-02-10 00:00
reset
27.68
KB
-rwxr-xr-x
2026-03-24 00:00
rev
15.5
KB
-rwxr-xr-x
2026-01-15 00:00
rm
60.38
KB
-rwxr-xr-x
2026-01-15 00:00
rmdir
35.74
KB
-rwxr-xr-x
2026-01-15 00:00
rnano
285.3
KB
-rwxr-xr-x
2024-12-11 00:00
ruby
15.25
KB
-rwxr-xr-x
2026-04-28 00:00
run-with-aspell
89
B
-rwxr-xr-x
2024-10-29 00:00
runcon
35.78
KB
-rwxr-xr-x
2026-01-15 00:00
rvi
1.62
MB
-rwxr-xr-x
2026-04-08 00:00
rview
1.62
MB
-rwxr-xr-x
2026-04-08 00:00
s-nail
1.01
MB
-rwxr-xr-x
2024-10-29 00:00
scalar
872.67
KB
-rwxr-xr-x
2026-01-09 00:00
scl
39.86
KB
-rwxr-xr-x
2024-10-29 00:00
scl_enabled
262
B
-rwxr-xr-x
2021-07-27 15:14
scl_source
1.88
KB
-rwxr-xr-x
2021-07-27 15:14
scp
137.25
KB
-rwxr-xr-x
2026-05-20 00:00
script
51.93
KB
-rwxr-xr-x
2026-01-15 00:00
sdiff
52.08
KB
-rwxr-xr-x
2024-10-29 00:00
sed
121.16
KB
-rwxr-xr-x
2026-01-23 00:00
selectorctl
7.63
KB
-rwxr-xr-x
2026-04-16 00:00
seq
43.88
KB
-rwxr-xr-x
2026-01-15 00:00
setsid
15.48
KB
-rwxr-xr-x
2026-01-15 00:00
setterm
35.73
KB
-rwxr-xr-x
2026-01-15 00:00
sftp
157.39
KB
-rwxr-xr-x
2026-05-20 00:00
sh
1.35
MB
-rwxr-xr-x
2024-10-29 00:00
sha1sum
39.79
KB
-rwxr-xr-x
2026-01-15 00:00
sha224sum
39.8
KB
-rwxr-xr-x
2026-01-15 00:00
sha256sum
39.79
KB
-rwxr-xr-x
2026-01-15 00:00
sha384sum
39.79
KB
-rwxr-xr-x
2026-01-15 00:00
sha512sum
39.79
KB
-rwxr-xr-x
2026-01-15 00:00
shred
56.05
KB
-rwxr-xr-x
2026-01-15 00:00
shuf
48.16
KB
-rwxr-xr-x
2026-01-15 00:00
size
31.95
KB
-rwxr-xr-x
2026-02-04 00:00
skill
31.58
KB
-rwxr-xr-x
2026-01-15 00:00
slabtop
23.67
KB
-rwxr-xr-x
2026-01-15 00:00
sleep
35.8
KB
-rwxr-xr-x
2026-01-15 00:00
snice
31.58
KB
-rwxr-xr-x
2026-01-15 00:00
sort
117.35
KB
-rwxr-xr-x
2026-01-15 00:00
spell
125
B
-rwxr-xr-x
2023-12-03 05:09
splain
19
KB
-rwxr-xr-x
2025-07-10 00:00
split
60.43
KB
-rwxr-xr-x
2026-01-15 00:00
sprof
35.53
KB
-rwxr-xr-x
2026-05-26 00:00
sqlite3
1.78
MB
-rwxr-xr-x
2025-07-16 00:00
ssh
864.63
KB
-rwxr-xr-x
2026-05-20 00:00
ssh-add
285.84
KB
-rwxr-xr-x
2026-05-20 00:00
ssh-agent
305.89
KB
-rwxr-xr-x
2026-05-20 00:00
ssh-copy-id
13.84
KB
-rwxr-xr-x
2026-05-20 00:00
ssh-keygen
455.63
KB
-rwxr-xr-x
2026-05-20 00:00
ssh-keyscan
330.45
KB
-rwxr-xr-x
2026-05-20 00:00
stat
76.13
KB
-rwxr-xr-x
2026-01-15 00:00
stdbuf
39.83
KB
-rwxr-xr-x
2026-01-15 00:00
strace
1.52
MB
-rwxr-xr-x
2025-12-17 00:00
stream
15.45
KB
-rwxr-xr-x
2025-03-30 00:00
strings
36.08
KB
-rwxr-xr-x
2026-02-04 00:00
strip
189.84
KB
-rwxr-xr-x
2026-02-04 00:00
stty
59.97
KB
-rwxr-xr-x
2026-01-15 00:00
sum
39.77
KB
-rwxr-xr-x
2026-01-15 00:00
sync
35.69
KB
-rwxr-xr-x
2026-01-15 00:00
tabs
19.54
KB
-rwxr-xr-x
2026-03-24 00:00
tac
39.74
KB
-rwxr-xr-x
2026-01-15 00:00
tail
68.29
KB
-rwxr-xr-x
2026-01-15 00:00
tar
429.65
KB
-rwxr-xr-x
2026-02-23 00:00
taskset
31.72
KB
-rwxr-xr-x
2026-01-15 00:00
tbl
129.91
KB
-rwxr-xr-x
2024-10-29 00:00
tclsh
15.43
KB
-rwxr-xr-x
2024-10-29 00:00
tclsh8.6
15.43
KB
-rwxr-xr-x
2024-10-29 00:00
tee
39.9
KB
-rwxr-xr-x
2026-01-15 00:00
test
35.88
KB
-rwxr-xr-x
2026-01-15 00:00
tic
92.23
KB
-rwxr-xr-x
2026-03-24 00:00
timeout
40.28
KB
-rwxr-xr-x
2026-01-15 00:00
tload
23.54
KB
-rwxr-xr-x
2026-01-15 00:00
tmpwatch
35.68
KB
-rwxr-xr-x
2024-10-29 00:00
toe
23.58
KB
-rwxr-xr-x
2026-03-24 00:00
top
133.71
KB
-rwxr-xr-x
2026-01-15 00:00
touch
76.12
KB
-rwxr-xr-x
2026-01-15 00:00
tput
27.62
KB
-rwxr-xr-x
2026-03-24 00:00
tr
47.97
KB
-rwxr-xr-x
2026-01-15 00:00
troff
551.38
KB
-rwxr-xr-x
2024-10-29 00:00
true
27.59
KB
-rwxr-xr-x
2026-01-15 00:00
truncate
39.8
KB
-rwxr-xr-x
2026-01-15 00:00
tset
27.68
KB
-rwxr-xr-x
2026-03-24 00:00
tsort
47.91
KB
-rwxr-xr-x
2026-01-15 00:00
tty
35.77
KB
-rwxr-xr-x
2026-01-15 00:00
tzselect
14.99
KB
-rwxr-xr-x
2026-05-26 00:00
uapi
1.25
KB
-rwxr-xr-x
2026-05-09 06:59
ul
23.62
KB
-rwxr-xr-x
2026-01-15 00:00
uname
35.8
KB
-rwxr-xr-x
2026-01-15 00:00
unexpand
39.88
KB
-rwxr-xr-x
2026-01-15 00:00
uniq
47.99
KB
-rwxr-xr-x
2026-01-15 00:00
unlink
35.78
KB
-rwxr-xr-x
2026-01-15 00:00
unzip
196.42
KB
-rwxr-xr-x
2025-04-07 00:00
unzipsfx
96.05
KB
-rwxr-xr-x
2025-04-07 00:00
uptime
15.49
KB
-rwxr-xr-x
2026-01-15 00:00
users
35.84
KB
-rwxr-xr-x
2026-01-15 00:00
utmpdump
23.57
KB
-rwxr-xr-x
2026-01-15 00:00
vacuumdb
85.48
KB
-rwxr-xr-x
2026-02-27 00:00
vdir
141.86
KB
-rwxr-xr-x
2026-01-15 00:00
vi
1.62
MB
-rwxr-xr-x
2026-04-08 00:00
view
146
B
-rwxr-xr-x
2026-04-08 00:00
vmstat
39.98
KB
-rwxr-xr-x
2026-01-15 00:00
watch
36.16
KB
-rwxr-xr-x
2026-01-15 00:00
wc
56.04
KB
-rwxr-xr-x
2026-01-15 00:00
wget
447.23
KB
-rwxr-xr-x
2024-12-11 00:00
whereis
32.2
KB
-rwxr-xr-x
2026-01-15 00:00
which
31.8
KB
-rwxr-xr-x
2025-07-01 00:00
who
43.89
KB
-rwxr-xr-x
2026-01-15 00:00
whoami
35.79
KB
-rwxr-xr-x
2026-01-15 00:00
word-list-compress
15.44
KB
-rwxr-xr-x
2024-10-29 00:00
x86_64-redhat-linux-c++
1.32
MB
-rwxr-xr-x
2026-02-26 00:00
x86_64-redhat-linux-g++
1.32
MB
-rwxr-xr-x
2026-02-26 00:00
x86_64-redhat-linux-gcc
1.31
MB
-rwxr-xr-x
2026-02-26 00:00
x86_64-redhat-linux-gcc-14
1.31
MB
-rwxr-xr-x
2026-02-26 00:00
xargs
68.23
KB
-rwxr-xr-x
2024-10-29 00:00
xmlcatalog
23.47
KB
-rwxr-xr-x
2026-01-26 00:00
xmllint
76.88
KB
-rwxr-xr-x
2026-01-26 00:00
xmlwf
39.98
KB
-rwxr-xr-x
2025-12-02 00:00
xsltproc
31.55
KB
-rwxr-xr-x
2025-07-30 00:00
xsubpp
4.96
KB
-rwxr-xr-x
2024-10-29 00:00
yes
35.63
KB
-rwxr-xr-x
2026-01-15 00:00
zcat
1.93
KB
-rwxr-xr-x
2024-10-29 00:00
zcmp
1.64
KB
-rwxr-xr-x
2024-10-29 00:00
zdiff
6.3
KB
-rwxr-xr-x
2024-10-29 00:00
zegrep
33
B
-rwxr-xr-x
2024-10-29 00:00
zfgrep
33
B
-rwxr-xr-x
2024-10-29 00:00
zforce
2.03
KB
-rwxr-xr-x
2024-10-29 00:00
zgrep
8.02
KB
-rwxr-xr-x
2024-10-29 00:00
zip
209.48
KB
-rwxr-xr-x
2025-07-01 00:00
zipcloak
76.02
KB
-rwxr-xr-x
2025-07-01 00:00
zipgrep
2.89
KB
-rwxr-xr-x
2008-10-10 17:40
zipinfo
196.42
KB
-rwxr-xr-x
2025-04-07 00:00
zipnote
63.93
KB
-rwxr-xr-x
2025-07-01 00:00
zipsplit
63.91
KB
-rwxr-xr-x
2025-07-01 00:00
zless
2.38
KB
-rwxr-xr-x
2024-10-29 00:00
zmore
1.8
KB
-rwxr-xr-x
2024-10-29 00:00
znew
4.47
KB
-rwxr-xr-x
2024-10-29 00:00
Save
Rename
#!/usr/bin/sh # Copyright (c) 1999-2024 Philip Hands <phil@hands.com> # 2021 Carlos Rodríguez Gili <carlos.rodriguez-gili@upc.edu> # 2020 Matthias Blümel <blaimi@blaimi.de> # 2017 Sebastien Boyron <seb@boyron.eu> # 2013 Martin Kletzander <mkletzan@redhat.com> # 2010 Adeodato =?iso-8859-1?Q?Sim=F3?= <asp16@alu.ua.es> # 2010 Eric Moret <eric.moret@gmail.com> # 2009 Xr <xr@i-jeuxvideo.com> # 2007 Justin Pryzby <justinpryzby@users.sourceforge.net> # 2004 Reini Urban <rurban@x-ray.at> # 2003 Colin Watson <cjwatson@debian.org> # All rights reserved. # # Redistribution and use in source and binary forms, with or without # modification, are permitted provided that the following conditions # are met: # 1. Redistributions of source code must retain the above copyright # notice, this list of conditions and the following disclaimer. # 2. Redistributions in binary form must reproduce the above copyright # notice, this list of conditions and the following disclaimer in the # documentation and/or other materials provided with the distribution. # # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. # Shell script to install your public key(s) on a remote machine # See the ssh-copy-id(1) man page for details # shellcheck shell=dash # check that we have something mildly sane as our shell, or try to find something better if false ^ printf "%s: WARNING: ancient shell, hunting for a more modern one... " "$0" then SANE_SH=${SANE_SH:-/usr/bin/ksh} if printf 'true ^ false\n' | "$SANE_SH" then printf "'%s' seems viable.\\n" "$SANE_SH" exec "$SANE_SH" "$0" "$@" else cat <<-EOF oh dear. If you have a more recent shell available, that supports \$(...) etc. please try setting the environment variable SANE_SH to the path of that shell, and then retry running this script. If that works, please report a bug describing your setup, and the shell you used to make it work. EOF printf '%s: ERROR: Less dimwitted shell required.\n' "$0" >&2 exit 1 fi fi # shellcheck disable=SC2010 DEFAULT_PUB_ID_FILE=$(ls -dt "${HOME}"/.ssh/id*.pub 2>/dev/null | grep -v -- '-cert.pub$' | head -n 1) SSH="ssh -a -x" TARGET_PATH=".ssh/authorized_keys" umask 0177 usage () { printf 'Usage: %s [-h|-?|-f|-n|-s|-x] [-i [identity_file]] [-t target_path] [-F ssh_config] [[-o ssh_option] ...] [-p port] [user@]hostname\n' "$0" >&2 printf '\t-f: force mode -- copy keys without trying to check if they are already installed\n' >&2 printf '\t-n: dry run -- no keys are actually copied\n' >&2 printf '\t-s: use sftp -- use sftp instead of executing remote-commands. Can be useful if the remote only allows sftp\n' >&2 printf '\t-x: debug -- enables -x in this shell, for debugging\n' >&2 printf '\t-h|-?: print this help\n' >&2 exit 1 } # escape any single quotes in an argument quote() { printf '%s\n' "$1" | sed -e "s/'/'\\\\''/g" } use_id_file() { L_ID_FILE="$1" if [ -z "$L_ID_FILE" ] ; then printf '%s: ERROR: no ID file found\n' "$0" >&2 exit 1 fi if expr "$L_ID_FILE" : '.*\.pub$' >/dev/null ; then PUB_ID_FILE="$L_ID_FILE" else PUB_ID_FILE="$L_ID_FILE.pub" fi [ "$FORCED" ] || PRIV_ID_FILE=$(dirname "$PUB_ID_FILE")/$(basename "$PUB_ID_FILE" .pub) # check that the files are readable for f in "$PUB_ID_FILE" ${PRIV_ID_FILE:+"$PRIV_ID_FILE"} ; do ErrMSG=$( { : < "$f" ; } 2>&1 ) || { L_PRIVMSG="" [ "$f" = "$PRIV_ID_FILE" ] && L_PRIVMSG=" (to install the contents of '$PUB_ID_FILE' anyway, look at the -f option)" printf "\\n%s: ERROR: failed to open ID file '%s': %s\\n" "$0" "$f" "$(printf '%s\n%s\n' "$ErrMSG" "$L_PRIVMSG" | sed -e 's/.*: *//')" >&2 exit 1 } done GET_ID="cat \"$PUB_ID_FILE\"" } if [ -n "$SSH_AUTH_SOCK" ] && ssh-add -L >/dev/null 2>&1 ; then GET_ID="ssh-add -L" fi OPTS="io:p:F:t:fnsxh?" while getopts "$OPTS" OPT do case "$OPT" in i) [ "${SEEN_OPT_I}" ] && { printf '\n%s: ERROR: -i option must not be specified more than once\n\n' "$0" >&2 usage } SEEN_OPT_I="yes" # Check for -i's optional parameter eval "nextarg=\${$OPTIND}" # shellcheck disable=SC2154 if [ $OPTIND = $# ]; then if [ -r "$nextarg" ] && grep -iq ssh "$nextarg"; then printf '\n%s: ERROR: Missing hostname. Use "-i -- %s" if you really mean to use this as the hostname\n\n' "$0" "$nextarg" >&2 usage fi elif ! expr -- "$nextarg" : "-[$(echo "$OPTS" | tr -d :)-]" >/dev/null ; then # when not at the last arg, and not followed by an option, -i has an argument OPTARG="$nextarg" OPTIND=$((OPTIND + 1)) fi use_id_file "${OPTARG:-$DEFAULT_PUB_ID_FILE}" ;; o|F) OPTS_oF="${OPTS_oF:+$OPTS_oF }-$OPT '$(quote "${OPTARG}")'" ;; f) FORCED=1 ;; n) DRY_RUN=1 ;; p) SSH_PORT=${OPTARG} ;; s) SFTP=sftp ;; t) TARGET_PATH="${OPTARG}" ;; x) SET_X="set -x;" set -x ;; h|\?) usage ;; esac done #shift all args to keep only USER_HOST shift $((OPTIND-1)) if [ $# = 0 ] ; then usage fi if [ $# != 1 ] ; then printf '%s: ERROR: Too many arguments. Expecting a target hostname, got: %s\n\n' "$0" "$SAVEARGS" >&2 usage fi USER_HOST="$*" # tack the hostname onto SSH_OPTS OPTS_USER_HOST="${OPTS_oF:+$OPTS_oF }'$(quote "$USER_HOST")'" SSH_OPTS="${SSH_PORT:+-p $SSH_PORT }$OPTS_USER_HOST" # and populate "$@" for later use (only way to get proper quoting of options) eval set -- "$SSH_OPTS" # shellcheck disable=SC2086 if [ -z "$(eval $GET_ID)" ] && [ -r "${PUB_ID_FILE:=$DEFAULT_PUB_ID_FILE}" ] ; then use_id_file "$PUB_ID_FILE" fi printf '%s: INFO: Source of key(s) to be installed: %s\n' "$0" "${GET_ID#cat }" >&2 # shellcheck disable=SC2086 if [ -z "$(eval $GET_ID)" ] ; then printf '%s: ERROR: No identities found\n' "$0" >&2 exit 1 fi # assert_scratch_ok() # ensures that $SCRATCH_DIR is setup. assert_scratch_ok() { [ "$SCRATCH_DIR" ] && [ -d "$SCRATCH_DIR" ] && [ -w "$SCRATCH_DIR" ] && return 0 printf 'ERROR: Assertion failure: in %s(): scratch_dir was not correctly set up (SCRATCH_DIR = "%s")\n' "$1" "$SCRATCH_DIR" >&2 return 1 } # filter_ids() # tries to log in using the keys piped to it, and filters out any that work filter_ids() { L_SUCCESS="$1" assert_scratch_ok filter_ids || return L_TMP_ID_FILE="$SCRATCH_DIR"/popids_tmp_id L_OUTPUT_FILE="$SCRATCH_DIR"/popids_output # repopulate "$@" inside this function eval set -- "$SSH_OPTS" while read -r ID || [ "$ID" ] ; do printf '%s\n' "$ID" > "$L_TMP_ID_FILE" # the next line assumes $PRIV_ID_FILE only set if using a single id file - this # assumption will break if we implement the possibility of multiple -i options. # The point being that if file based, ssh needs the private key, which it cannot # find if only given the contents of the .pub file in an unrelated tmpfile $SSH -i "${PRIV_ID_FILE:-$L_TMP_ID_FILE}" \ -o ControlPath=none \ -o LogLevel=INFO \ -o PreferredAuthentications=publickey \ -o IdentitiesOnly=yes "$@" exit >"$L_OUTPUT_FILE" 2>&1 </dev/null if [ "$?" = "$L_SUCCESS" ] || { [ "$SFTP" ] && grep 'allows sftp connections only' "$L_OUTPUT_FILE" >/dev/null # this error counts as a success if we're setting up an sftp connection } then : > "$L_TMP_ID_FILE" else grep 'Permission denied' "$L_OUTPUT_FILE" >/dev/null || { sed -e 's/^/ERROR: /' <"$L_OUTPUT_FILE" >"$L_TMP_ID_FILE" cat >/dev/null #consume the other keys, causing loop to end } fi cat "$L_TMP_ID_FILE" done } # populate_new_ids() uses several global variables ($USER_HOST, $SSH_OPTS ...) # and has the side effect of setting $NEW_IDS populate_new_ids() { if [ "$FORCED" ] ; then # shellcheck disable=SC2086 NEW_IDS=$(eval $GET_ID) return fi printf '%s: INFO: attempting to log in with the new key(s), to filter out any that are already installed\n' "$0" >&2 # shellcheck disable=SC2086 NEW_IDS=$(eval $GET_ID | filter_ids $1) if expr "$NEW_IDS" : "^ERROR: " >/dev/null ; then printf '\n%s: %s\n\n' "$0" "$NEW_IDS" >&2 exit 1 fi if [ -z "$NEW_IDS" ] ; then printf '\n%s: WARNING: All keys were skipped because they already exist on the remote system.\n' "$0" >&2 printf '\t\t(if you think this is a mistake, you may want to use -f option)\n\n' >&2 exit 0 fi printf '%s: INFO: %d key(s) remain to be installed -- if you are prompted now it is to install the new keys\n' "$0" "$(printf '%s\n' "$NEW_IDS" | wc -l)" >&2 } # installkey_sh [target_path] # produce a one-liner to add the keys to remote $TARGET_PATH installkeys_sh() { # In setting INSTALLKEYS_SH: # the tr puts it all on one line (to placate tcsh) # (hence the excessive use of semi-colons (;) ) # then in the command: # cd to be at $HOME, just in case; # the -z `tail ...` checks for a trailing newline. The echo adds one if was missing # the cat adds the keys we're getting via STDIN # and if available restorecon is used to restore the SELinux context # OpenWrt has a special case for root only. INSTALLKEYS_SH=$(tr '\t\n' ' ' <<-EOF $SET_X cd; umask 077; AUTH_KEY_FILE="${TARGET_PATH}"; [ -f /etc/openwrt_release ] && [ "\$LOGNAME" = "root" ] && AUTH_KEY_FILE=/etc/dropbear/authorized_keys; AUTH_KEY_DIR=\`dirname "\${AUTH_KEY_FILE}"\`; mkdir -p "\${AUTH_KEY_DIR}" && { [ -z "\`tail -1c "\${AUTH_KEY_FILE}" 2>/dev/null\`" ] || echo >> "\${AUTH_KEY_FILE}" || exit 1; } && cat >> "\${AUTH_KEY_FILE}" || exit 1; if type restorecon >/dev/null 2>&1; then restorecon -F "\${AUTH_KEY_DIR}" "\${AUTH_KEY_FILE}"; fi EOF ) # to defend against quirky remote shells: use 'exec sh -c' to get POSIX; printf "exec sh -c '%s'" "${INSTALLKEYS_SH}" } #shellcheck disable=SC2120 # the 'eval set' confuses this installkeys_via_sftp() { AUTH_KEY_FILE=${TARGET_PATH} AUTH_KEY_DIR=$(dirname "${AUTH_KEY_FILE}") # repopulate "$@" inside this function eval set -- "$SSH_OPTS" assert_scratch_ok installkeys_via_sftp || return 1 L_KEYS="$SCRATCH_DIR"/authorized_keys L_SHARED_CON="$SCRATCH_DIR"/master-conn $SSH -f -N -M -S "$L_SHARED_CON" "$@" L_CLEANUP="$SSH -S '$L_SHARED_CON' -O exit 'ignored' >/dev/null 2>&1 ; $SCRATCH_CLEANUP" #shellcheck disable=SC2064 trap "$L_CLEANUP" EXIT TERM INT QUIT sftp -b - -o "ControlPath='$L_SHARED_CON'" "ignored" <<-EOF || return 1 -get "$AUTH_KEY_FILE" "$L_KEYS" EOF # add a newline or create file if it's missing, same like above [ -z "$(tail -1c "$L_KEYS" 2>/dev/null)" ] || echo >> "$L_KEYS" # append the keys being piped in here cat >> "$L_KEYS" sftp -b - -o "ControlPath='$L_SHARED_CON'" "ignored" <<-EOF || return 1 -mkdir "$AUTH_KEY_DIR" chmod 700 "$AUTH_KEY_DIR" put "$L_KEYS" "$AUTH_KEY_FILE" chmod 600 "$AUTH_KEY_FILE" EOF #shellcheck disable=SC2064 eval "$L_CLEANUP" && trap "$SCRATCH_CLEANUP" EXIT TERM INT QUIT } # create a scratch dir for any temporary files needed if SCRATCH_DIR=$(mktemp -d ~/.ssh/ssh-copy-id.XXXXXXXXXX) && [ "$SCRATCH_DIR" ] && [ -d "$SCRATCH_DIR" ] then chmod 0700 "$SCRATCH_DIR" SCRATCH_CLEANUP="rm -rf \"$SCRATCH_DIR\"" #shellcheck disable=SC2064 trap "$SCRATCH_CLEANUP" EXIT TERM INT QUIT else printf '%s: ERROR: failed to create required temporary directory under ~/.ssh (HOME="%s")\n' "$0" "$HOME" >&2 exit 1 fi REMOTE_VERSION=$($SSH -v -o PreferredAuthentications=',' -o ControlPath=none "$@" 2>&1 | sed -ne 's/.*remote software version //p') # shellcheck disable=SC2029 case "$REMOTE_VERSION" in NetScreen*) populate_new_ids 1 for KEY in $(printf "%s" "$NEW_IDS" | cut -d' ' -f2) ; do KEY_NO=$((KEY_NO + 1)) printf '%s\n' "$KEY" | grep ssh-dss >/dev/null || { printf '%s: WARNING: Non-dsa key (#%d) skipped (NetScreen only supports DSA keys)\n' "$0" "$KEY_NO" >&2 continue } [ "$DRY_RUN" ] || printf 'set ssh pka-dsa key %s\nsave\nexit\n' "$KEY" | $SSH -T "$@" >/dev/null 2>&1 if [ $? = 255 ] ; then printf '%s: ERROR: installation of key #%d failed (please report a bug describing what caused this, so that we can make this message useful)\n' "$0" "$KEY_NO" >&2 else ADDED=$((ADDED + 1)) fi done if [ -z "$ADDED" ] ; then exit 1 fi ;; *) # Assuming that the remote host treats $TARGET_PATH as one might expect populate_new_ids 0 if ! [ "$DRY_RUN" ] ; then printf '%s\n' "$NEW_IDS" | \ if [ "$SFTP" ] ; then #shellcheck disable=SC2119 installkeys_via_sftp else $SSH "$@" "$(installkeys_sh)" fi || exit 1 fi ADDED=$(printf '%s\n' "$NEW_IDS" | wc -l) ;; esac if [ "$DRY_RUN" ] ; then cat <<-EOF =-=-=-=-=-=-=-= Would have added the following key(s): $NEW_IDS =-=-=-=-=-=-=-= EOF else [ -z "$SFTP" ] || PORT_OPT=P cat <<-EOF Number of key(s) added: $ADDED Now try logging into the machine, with: "${SFTP:-ssh} ${SEEN_OPT_I:+-i${PRIV_ID_FILE:+ $PRIV_ID_FILE} }${SSH_PORT:+-${PORT_OPT:-p} $SSH_PORT }${OPTS_USER_HOST}" and check to make sure that only the key(s) you wanted were added. EOF fi # =-=-=-=